import {
  Controller,
  Post,
  Put,
  Delete,
  Route,
  Security,
  Tags,
  Body,
  Path,
  Request,
  Response,
  Get,
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import HttpSuccess from "../interfaces/http-success";
import HttpStatusCode from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { CreateReligion, Religion } from "../entities/Religion";
import { Not } from "typeorm";
import { setLogDataDiff } from "../interfaces/utils";
import { RequestWithUser } from "../middlewares/user";
@Route("api/v1/org/metadata/religion")
@Tags("Religion")
@Security("bearerAuth")
@Response(
  HttpStatusCode.INTERNAL_SERVER_ERROR,
  "เกิดข้อผิดพลาด ไม่สามารถแสดงรายการได้ กรุณาลองใหม่ในภายหลัง",
)
export class ReligionController extends Controller {
  private religionRepository = AppDataSource.getRepository(Religion);

  /**
   * API สร้างศาสนา
   *
   * @summary ORG_059 - สร้างศาสนา (ADMIN) #65
   *
   */
  @Post()
  async createReligion(
    @Body()
    requestBody: CreateReligion,
    @Request() request: RequestWithUser,
  ) {
    const checkName = await this.religionRepository.findOne({
      where: { name: requestBody.name },
    });

    if (checkName) {
      throw new HttpError(HttpStatusCode.NOT_FOUND, "ชื่อนี้มีอยู่ในระบบแล้ว");
    }
    const before = null;
    const religion = Object.assign(new Religion(), requestBody);
    religion.createdUserId = request.user.sub;
    religion.createdFullName = request.user.name;
    religion.lastUpdateUserId = request.user.sub;
    religion.lastUpdateFullName = request.user.name;
    religion.createdAt = new Date();
    religion.lastUpdatedAt = new Date();
    await this.religionRepository.save(religion, { data: request });
    setLogDataDiff(request, { before, after: religion });
    return new HttpSuccess();
  }

  /**
   * API แก้ไขศาสนา
   *
   * @summary ORG_059 - แก้ไขศาสนา (ADMIN) #65
   *
   * @param {string} id  Id ศาสนา
   */
  @Put("{id}")
  async updateReligion(
    @Path() id: string,
    @Body()
    requestBody: CreateReligion,
    @Request() request: RequestWithUser,
  ) {
    const religion = await this.religionRepository.findOne({ where: { id: id } });
    if (!religion) {
      throw new HttpError(HttpStatusCode.NOT_FOUND, "ไม่พบข้อมูลศาสนานี้");
    }

    const checkName = await this.religionRepository.findOne({
      where: { id: Not(id), name: requestBody.name },
    });

    if (checkName) {
      throw new HttpError(HttpStatusCode.NOT_FOUND, "ชื่อนี้มีอยู่ในระบบแล้ว");
    }
    const before = structuredClone(religion);
    religion.lastUpdateUserId = request.user.sub;
    religion.lastUpdateFullName = request.user.name;
    religion.lastUpdatedAt = new Date();
    this.religionRepository.merge(religion, requestBody);
    await this.religionRepository.save(religion, { data: request });
    setLogDataDiff(request, { before, after: religion });
    return new HttpSuccess();
  }

  /**
   * API ลบศาสนา
   *
   * @summary ORG_059 - ลบศาสนา (ADMIN) #65
   *
   * @param {string} id  Id ศาสนา
   */
  @Delete("{id}")
  async deleteReligion(@Path() id: string, @Request() request: RequestWithUser) {
    const delReligion = await this.religionRepository.findOne({
      where: { id },
    });
    if (!delReligion) {
      throw new HttpError(HttpStatusCode.NOT_FOUND, "ไม่พบข้อมูลศาสนานี้");
    }
    await this.religionRepository.remove(delReligion, { data: request });
    return new HttpSuccess();
  }

  /**
   * API รายละเอียดรายการศาสนา
   *
   * @summary ORG_059 - รายละเอียดรายการศาสนา  (ADMIN) #65
   *
   * @param {string} id  Id ศาสนา
   */
  @Get("{id}")
  async detailReligion(@Path() id: string) {
    const religion = await this.religionRepository.findOne({
      where: { id },
      select: ["id", "name"],
    });
    if (!religion) {
      throw new HttpError(HttpStatusCode.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(religion);
  }

  /**
   * API รายการศาสนา
   *
   * @summary ORG_059 - รายการศาสนา (ADMIN) #65
   *
   */
  @Get()
  async listReligion() {
    const religion = await this.religionRepository.find({
      select: ["id", "name", "createdAt", "lastUpdatedAt", "createdFullName", "lastUpdateFullName"],
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(religion);
  }
}
